unit GrMouse;
interface
type MouseCursorType = array [1..2,1..16] of word;
var MouseInstalled: boolean;
    MouseCursorOn:boolean;
Function InitMouse:Boolean;
{Call it after InitGraph}
procedure ReadMouse(var x,y:integer;var key:byte);
Procedure SetMouseXY( x,y:integer);
procedure ShowMouse ;
procedure hideMouse ;
procedure SetCursorShape(var Cursor : MouseCursorType ; HotPointX , HotPointY : byte);
Procedure SetMouseWindow (X1,y1,x2,y2:integer);
implementation
uses dos,graph;
procedure ShowMousePrim ; inline (
$B8/$01/$00/
$CD/$33);
procedure hideMousePrim ; inline (
$B8/$02/$00/
$CD/$33);
Procedure ShowMouse;
Begin
 If MouseInstalled and not MouseCursorOn then
  begin
   ShowMousePrim;
   MouseCursorOn:=True;
  end;
end;
Procedure HideMouse;
Begin
 If MouseInstalled and  MouseCursorOn then
  begin
   HideMousePrim;
   MouseCursorOn:=False;
  end;
end;
procedure SetCursorShape(var Cursor : MouseCursorType ; HotPointX , HotPointY : byte);
var r:registers;
begin
if not MouseInstalled then exit;
r.ax:=9;
r.bx:= HotPointX ;
r.cx:= HotPointY ;
r.es:=seg(Cursor);
r.dx:=ofs(Cursor);
intr($33,r);
end;
procedure ReadMouse(var x,y:integer;var key:byte);
  var r:registers;
  begin
   if not MouseInstalled then Exit;
   r.ax:=$0003;
   Intr($33,r);
   x:=r.cx;
   y:=r.dx;
   key:=r.bl;
  end;
Procedure SetMouseXY (x,y:integer);
var r:registers;
begin
 If not MouseInstalled then exit;
 r.cx:=x;
 r.dx:=y;
 r.ax:=4;
 intr($33,r);
end;
Procedure SetMouseWindow (X1,y1,x2,y2:integer);
var r:registers;
begin
 if not MouseInstalled then exit;
 r.cx:=x1;
 r.dx:=x2;
 r.ax:=7;
 intr($33,r);
 r.cx:=y1;
 r.dx:=y2;
 r.ax:=8;
 intr($33,r);
end;
Function InitMouse:boolean;
var p: pointer ;
Function Init:integer;inline(
$B8/00/00/
$CD/$33);

begin
 InitMouse := False ;
 MouseInstalled:=False;
 GetIntVec ( $33 , p ) ;
 if p=nil then exit ; {Interrupt vector points nowhere}
 if init <> -1 then exit ; { Call of initialization function is not
			     successiful}
 InitMouse := True ;
 MouseInstalled:=True ;
 MouseCursorOn := False;
 SetMouseWindow ( 0 , 0 , GetMaxX , GetMaxY );
end;
end.

